/*
  $Id: statsgen.cc 4025 2008-10-01 00:01:14Z abehm $

  Copyright (C) 2007 by The Regents of the University of California
	
  Redistribution of this file is permitted under
  the terms of the BSD license
    
  Date: 09/17/2007
  Author: Alexander Behm <abehm (at) ics.uci.edu>
*/

#include "statsgen.h"
#include "util/input.h"
#include "util/misc.h"

StatsGenConfig::
StatsGenConfig() {
  numberQueries = 0;
  dictSizeStart = 0;
  dictSizeStop = 0;
  dictSizeStep = 0;
  maxStrLength = 0;
  queriesDistrib = QD_UNIFORM;
  distinctQueries = 0;
  numberRuns = 1;
  zipfSkew = 1;
  outputFile = "search_stats.txt";
  overrideWorkload = false;
  rebuildIndexEveryRun = true;
}

void 
StatsGenConfig::
clearFilters() { 
  for(unsigned i = 0; i < filterTypes.size(); i++) {
    AbstractFilter* f = filterTypes.at(i);
    if(f) delete f;
  }
}  


template<>
StringContainerVector*
createDefaultStringContainer() {
  return new StringContainerVector(); 
}

template<>
StringContainerVector*
createDefaultStringContainer(StatsGenConfig* config) {
  return new StringContainerVector(); 
}
